  private final void writeBaseTypeArray(Object obj)
	throws IOException {
    MetaClass mc = MetaClass.get(obj);
    String sig = mc.signature();

    flushNull();

    // Ĺ
    writeInt(MetaArray.length(obj));

    // signature Ƭ `[' ڤȤ
    sig = sig.substring(1);

    if (Signature.isByte(sig)) {
      writeByteArray((byte[])obj);
    }
    else if (Signature.isChar(sig)) {
      writeCharArray((char[])obj);
    }
    else if (Signature.isDouble(sig)) {
      writeDoubleArray((double[])obj);
    }
    else if (Signature.isFloat(sig)) {
      writeFloatArray((float[])obj);
    }
    else if (Signature.isInt(sig)) {
      writeIntArray((int[])obj);
    }
    else if (Signature.isLong(sig)) {
      writeLongArray((long[])obj);
    }
    else if (Signature.isShort(sig)) {
      writeShortArray((short[])obj);
    }
    else if (Signature.isBoolean(sig)) {
      writeBooleanArray((boolean[])obj);
    }
    else {
      // not reached.
      // 顼  not implemented yet.
    }
  }

  private void writeByteArray(byte[] ary) throws IOException {
    for (int i = 0; i < ary.length; i++) {
      writeByte(ary[i]);
    }
  }

  private void writeCharArray(char[] ary) throws IOException {
    for (int i = 0; i < ary.length; i++) {
      writeChar(ary[i]);
    }
  }

  private void writeDoubleArray(double[] ary) throws IOException {
    for (int i = 0; i < ary.length; i++) {
      writeDouble(ary[i]);
    }
  }

  private void writeFloatArray(float[] ary) throws IOException {
    for (int i = 0; i < ary.length; i++) {
      writeFloat(ary[i]);
    }
  }

  private void writeIntArray(int[] ary) throws IOException {
    for (int i = 0; i < ary.length; i++) {
      writeInt(ary[i]);
    }
  }

  private void writeLongArray(long[] ary) throws IOException {
    for (int i = 0; i < ary.length; i++) {
      writeLong(ary[i]);
    }
  }

  private void writeShortArray(short[] ary) throws IOException {
    for (int i = 0; i < ary.length; i++) {
      writeShort(ary[i]);
    }
  }

  private void writeBooleanArray(boolean[] ary) throws IOException {
    for (int i = 0; i < ary.length; i++) {
      writeBoolean(ary[i]);
    }
  }
