/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.reflect;

public
class Signature {
  String mySignature = null;

  Signature(String sig) {
    mySignature = sig;
  }

  public boolean isObject() { return isObject(mySignature); }
  public boolean isBaseType() { return isBaseType(mySignature); }
  public boolean isArray() { return isArray(mySignature); }
  public boolean isObjectArray() { return isObjectArray(mySignature); }
  public boolean isBaseTypeArray() { return isBaseTypeArray(mySignature); }

  public static boolean isObject(String sig) {
    char c = sig.charAt(0);  return ((c == 'L') || (c == '['));
  }
  public static boolean isBaseType(String sig) {
    char c = sig.charAt(0);  return ((c != 'L') && (c != '['));
  }
  public static boolean isArray(String sig) {
    char c = sig.charAt(0);  return (c == '[');
  }
  public static boolean isObjectArray(String sig) {
    char c0 = sig.charAt(0);  char c1 = sig.charAt(1);
    return ((c0 == '[') && ((c1 == 'L') || (c1 == '[')));
  }
  public static boolean isBaseTypeArray(String sig) {
    char c0 = sig.charAt(0);  char c1 = sig.charAt(1);
    return ((c0 == '[') && ((c1 != 'L') && (c1 != '[')));
  }

  public boolean isAny() { return isAny(mySignature); }
  public boolean isEnum() { return isEnum(mySignature); }
  public boolean isVoid() { return isVoid(mySignature); }
  public boolean isBoolean() { return isBoolean(mySignature); }
  public boolean isByte() { return isByte(mySignature); }
  public boolean isChar() { return isChar(mySignature); }
  public boolean isShort() { return isShort(mySignature); }
  public boolean isInt() { return isInt(mySignature); }
  public boolean isLong() { return isLong(mySignature); }
  public boolean isFloat() { return isFloat(mySignature); }
  public boolean isDouble() { return isDouble(mySignature); }

  public static boolean isAny(String sig) {
    char c = sig.charAt(0);  return (c == 'A');
  }
  public static boolean isEnum(String sig) {
    char c = sig.charAt(0);  return (c == 'E');
  }
  public static boolean isVoid(String sig) {
    char c = sig.charAt(0);  return (c == 'V');
  }
  public static boolean isBoolean(String sig) {
    char c = sig.charAt(0);  return (c == 'Z');
  }
  public static boolean isByte(String sig) {
    char c = sig.charAt(0);  return (c == 'B');
  }
  public static boolean isChar(String sig) {
    char c = sig.charAt(0);  return (c == 'C');
  }
  public static boolean isShort(String sig) {
    char c = sig.charAt(0);  return (c == 'S');
  }
  public static boolean isInt(String sig) {
    char c = sig.charAt(0);  return (c == 'I');
  }
  public static boolean isLong(String sig) {
    char c = sig.charAt(0);  return (c == 'J');
  }
  public static boolean isFloat(String sig) {
    char c = sig.charAt(0);  return (c == 'F');
  }
  public static boolean isDouble(String sig) {
    char c = sig.charAt(0);  return (c == 'D');
  }
}
